def exponentiation_rapide(a:int, b:int, n:int) -> int:
    """Renvoi a^b [n] calculé par une méthode d'exponentiation rapide"""
    if .....:     # Cas de base
        return .....      # On renvoi a modulo n
    if b % 2 == 0:    # Si l'exposant est pair
        # On renvoit le produit de {a^(b//2) [n]  x a^(b//2) [n]} [n]
        return (  (.....................................) \
                * (.....................................) ) % n
    else:  # Si impair
        # On renvoit le produit de {a^(b//2) [n]  x a^(b//2 + 1) [n]} [n]
        return (  (.....................................)\
                * (.......................................) ) % n


assert exponentiation_rapide(3, 15, 50) == 7
assert exponentiation_rapide(2, 10, 2000) == 1024
assert exponentiation_rapide(42730, 56890, 200) == 0
assert exponentiation_rapide(99999999, 99999999, 2**128) != 0
